// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "TraceEvent.h"                                              // *** JMN
#include "LogFrame.h"                                                // *** JMN
#include "Log.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDM_TEST_COMMENT, OnTestComment)
	ON_COMMAND(IDM_TEST_ERROR, OnTestError)
	ON_COMMAND(IDM_TEST_FORMATERROR, OnTestFormaterror)
	ON_COMMAND(IDM_TRACE_FORMATMESSAGE, OnTraceFormatmessage)
	ON_UPDATE_COMMAND_UI(IDM_TRACE_FORMATMESSAGE, OnUpdateTraceFormatmessage)
	ON_UPDATE_COMMAND_UI(IDM_TEST_FORMATERROR, OnUpdateTestFormaterror)
	ON_UPDATE_COMMAND_UI(IDM_TEST_ERROR, OnUpdateTestError)
	ON_UPDATE_COMMAND_UI(IDM_TEST_COMMENT, OnUpdateTestComment)
	ON_COMMAND(IDM_TEST_DATA_BINARY, OnTestDataBinary)
	ON_UPDATE_COMMAND_UI(IDM_TEST_DATA_BINARY, OnUpdateTestDataBinary)
	ON_COMMAND(IDM_TEST_DATA_STRING, OnTestDataString)
	ON_UPDATE_COMMAND_UI(IDM_TEST_DATA_STRING, OnUpdateTestDataString)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
 FormatErrorCount = 0;	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnTestComment() 
{
 CLogApp::Logger.AddString(new TraceComment(TraceEvent::None, IDS_SAMPLE_COMMENT));
}

void CMainFrame::OnTestError() 
{
 CLogApp::Logger.AddString(new TraceError(TraceEvent::None, "=============="));
 CLogApp::Logger.AddString(new TraceError(TraceEvent::None, IDS_SAMPLE_ERROR));
	
}

void CMainFrame::OnTestFormaterror() 
{
 FormatErrorCount++;
 CLogApp::Logger.AddString(new TraceFormatError(TraceEvent::None,
						FormatErrorCount == 1
						    ? IDS_ERROR_COUNT_1
                                                    : IDS_ERROR_COUNT,
						FormatErrorCount)); 
}

void CMainFrame::OnTraceFormatmessage() 
{
 CLogApp::Logger.AddString(new TraceError(TraceEvent::None, IDS_SAMPLE_ACCESS_DENIED));
 CLogApp::Logger.AddString(new TraceFormatMessage(TraceEvent::None, ERROR_ACCESS_DENIED));
}

void CMainFrame::OnUpdateTraceFormatmessage(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(CLogApp::Logger.IsValid());
}

void CMainFrame::OnUpdateTestFormaterror(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(CLogApp::Logger.IsValid());
}

void CMainFrame::OnUpdateTestError(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(CLogApp::Logger.IsValid());
}

void CMainFrame::OnUpdateTestComment(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(CLogApp::Logger.IsValid());
}

void CMainFrame::OnTestDataBinary() 
{
 CString s = _T("This is some sample data");
 CLogApp::Logger.AddString(new TraceData(TraceEvent::None, (LPBYTE)(LPCTSTR)s, s.GetLength() * sizeof(TCHAR)));
}

void CMainFrame::OnUpdateTestDataBinary(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(CLogApp::Logger.IsValid());
}

void CMainFrame::OnTestDataString() 
{
 CString s = _T("This is some sample data");
 CLogApp::Logger.AddString(new TraceData(TraceEvent::None, s));
}

void CMainFrame::OnUpdateTestDataString(CCmdUI* pCmdUI) 
{
 pCmdUI->Enable(CLogApp::Logger.IsValid());
}
